"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Copyright (c) 2017-present, Facebook, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */

exports.default = function (realm) {
  var global = realm.$GlobalObject;

  // module.exports support
  var moduleValue = _index.AbstractValue.createAbstractObject(realm, "module");
  global.$DefineOwnProperty("module", {
    value: moduleValue,
    writable: true,
    enumerable: false,
    configurable: true
  });

  var babelHelpersValue = realm.$GlobalEnv.evaluate(babelHelpersAST, false);
  (0, _invariant2.default)(babelHelpersValue instanceof _index.ObjectValue);
  global.$DefineOwnProperty("babelHelpers", {
    value: babelHelpersValue,
    writable: true,
    enumerable: true,
    configurable: true
  });

  // apply React mock (for now just React.Component)
  global.$DefineOwnProperty("require", {
    value: new _index.NativeFunctionValue(realm, "global.require", "require", 0, function (context, _ref) {
      var _ref2 = _slicedToArray(_ref, 1),
          requireNameVal = _ref2[0];

      (0, _invariant2.default)(requireNameVal instanceof _index.StringValue);
      var requireNameValValue = requireNameVal.value;

      if (requireNameValValue === "react" || requireNameValValue === "React") {
        if (realm.fbLibraries.react === undefined) {
          var react = (0, _reactMocks.createMockReact)(realm, requireNameValValue);
          realm.fbLibraries.react = react;
          return react;
        }
        return realm.fbLibraries.react;
      } else if (requireNameValValue === "react-relay" || requireNameValValue === "RelayModern") {
        if (realm.fbLibraries.reactRelay === undefined) {
          var reactRelay = (0, _relayMocks.createMockReactRelay)(realm, requireNameValValue);
          realm.fbLibraries.reactRelay = reactRelay;
          return reactRelay;
        }
        return realm.fbLibraries.reactRelay;
      }
      var requireName = "require(\"" + requireNameVal.value + "\")";
      var type = _index.Value.getTypeFromName("function");
      var requireValue = _index.AbstractValue.createFromTemplate(realm, (0, _builder2.default)(requireName), type, [], requireName);
      requireValue.intrinsicName = requireName;
      return requireValue;
    }),
    writable: true,
    enumerable: false,
    configurable: true
  });
};

var _babylon = require("babylon");

var _index = require("../../values/index.js");

var _builder = require("../../utils/builder.js");

var _builder2 = _interopRequireDefault(_builder);

var _reactMocks = require("./react-mocks.js");

var _relayMocks = require("./relay-mocks.js");

var _invariant = require("../../invariant");

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Based on www babelHelpers fork.
var babelHelpersCode = "\n{\n  inherits(subClass, superClass) {\n    Object.assign(subClass, superClass);\n    subClass.prototype = Object.create(superClass && superClass.prototype);\n    subClass.prototype.constructor = subClass;\n    subClass.__superConstructor__ = superClass;\n    return superClass;\n  },\n  _extends: Object.assign,\n  extends: Object.assign,\n  objectWithoutProperties(obj, keys) {\n    var target = {};\n    for (var i in obj) {\n      if (!hasOwn.call(obj, i) || keys.indexOf(i) >= 0) {\n        continue;\n      }\n      target[i] = obj[i];\n    }\n    return target;\n  },\n  taggedTemplateLiteralLoose(strings, raw) {\n    strings.raw = raw;\n    return strings;\n  },\n  bind: Function.prototype.bind,\n}\n";
var babelHelpersAST = (0, _babylon.parseExpression)(babelHelpersCode);
//# sourceMappingURL=global.js.map